/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : CLOC
Version : 
Date    : 20.02.2011
Author  : NeVaDa
Company : RUSSIA
Comments:


Chip type               : ATtiny2313
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 32
*****************************************************/

#include <tiny2313.h>
 #asm
.equ __i2c_port=0x18
.equ __sda_bit=3
.equ __scl_bit=2
#endasm
#include <ds1307.h>
#include <bcd.h>
#include <delay.h>
#define    Out  PORTD.6    // Speaker
eeprom unsigned char tabkod[13]={0b10000011,0b10100011,0b10110011,0b00010011,0b00100011,0b01100011,0b01000011,0b00000011,0b00110011,0b10010011,0,0}; // :     2      

unsigned char hour=0,minuti=0,second=0,temp=0,catod=1;
unsigned char regim=0,regimA=0;
unsigned char date=0,month=0,year=0;
unsigned char hor=0,min=0,sec=0;
unsigned int  count=0;
bit mig=0,mig1=0,mig2=0;
bit Play=0;
unsigned char bufer;


unsigned  int    T1Reload=0;
unsigned int    index=0;
unsigned  int     lang=0;


// Timer 0 overflow interrupt service routine
interrupt [TIMER0_COMPA] void timer0_compa_isr (void)
{
unsigned char sek1,sek10,min1,min10,has1,has10;
// Place your code here
       temp=bin2bcd(sec);
       sek1=temp;
       sek1&=0b00001111;
       temp&=0b11110000;
       sek10=temp>>4;

       temp=bin2bcd(min);
       min1=temp;
       min1&=0b00001111;
       temp&=0b11110000;
       min10=temp>>4;  

       temp=bin2bcd(hor);
       has1=temp;
       has1&=0b00001111;
       temp&=0b11110000;
       has10=temp>>4;
  
PORTD.5=1;PORTD.4=1;PORTD.3=1;PORTD.2=1;PORTD.1=1;PORTD.0=1;     
       
 if(mig==0)
  {                           
  if(catod==32) {PORTD.5=0,PORTB=tabkod[has10];} 
  if(catod==16) {PORTD.4=0,PORTB=tabkod[has1];}
  }
  else //  
  {
  if(catod==32) {PORTD=127;} 
  if(catod==16) {PORTD=127;}
  }
 if(mig1==0)
  {
  if(catod==8) {PORTD.3=0,PORTB=tabkod[min10];}
  if(catod==4) {PORTD.2=0,PORTB=tabkod[min1];}
  }
  else  //  
  {
  if(catod==8) {PORTD=127;} 
  if(catod==4) {PORTD=127;}
  }
 if(mig2==0)
  {
  if(catod==2) {PORTD.1=0,PORTB=tabkod[sek10];} 
  if(catod==1) {PORTD.0=0,PORTB=tabkod[sek1];}
  }
  else  //  
  {
  if(catod==2) {PORTD=127;} 
  if(catod==1) {PORTD=127;}
  }
catod<<=1;
if(catod==64){catod=1;}
    return;
}

void main(void)
{
{
// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Port B initialization
PORTB=0xFF;
DDRB=0xFC;
// Port D initialization 
PORTD=0x00;
DDRD=0x7F;
// Timer/Counter 0 initialization
    TCCR0A=0x00;
    TCCR0B=0x02;
    OCR0A=250;
 
 TIMSK=0b00000001;
// Universal Serial Interface initialization
ACSR=0x80;
// Global enable interrupts
#asm("sei")
} 
     i2c_init();
     rtc_init(0,0,0);
     rtc_get_date(&date,&month,&year);
while (1)
 {   
       
    if(Play==1)//   
     {      
      if(lang!=15){if(T1Reload==0){Out=!Out;T1Reload=4000;lang++;}}
      else{if(index!=4000){index++;Out=1;}else{index=0;lang=0;}}
     }
     else {index = 0;Out = 1;}

     count++; 
     while(count==22000)      
     {
       if(PINB.0==0&PINB.1==0)   //  
       {
        if(regim==3){regim=0;}      //  
        else{regim++;}
        regimA=0;bufer=0;
        while(PINB.0==0&PINB.1==0){} //   
       }
       if(PINB.0==1&PINB.1==0&mig==mig1==mig2)   // 
       { 
         if(regim==0){Play=0;}
         bufer++;
         if(regim==1 || regim==2)
          {
          if(regimA==1){if(bufer>=60){bufer=0;}}
          if(regimA==2){if(bufer>=24){bufer=0;}}
          if(regimA==3){regimA=0;}
          } 

           if(regim==3)
          {
          if(regimA==1){if(bufer>=100){bufer=0;}}
          if(regimA==2){if(bufer>=13){bufer=0;}}
          if(regimA==3){if(bufer>=32){bufer=0;}} 
          } 
           
       }
       if(PINB.0==0&PINB.1==1)   //   
       {
        bufer=0;
        if(regimA==3){regimA=0;}      //  
        else(regimA++);
        while(PINB.0==0&PINB.1==1){} //   
       }
      

       while(regim==0)// . , ,    . .
       {
        mig=0,mig1=0;mig2=0;  
        rtc_get_time(&hour,&minuti,&second); //   ds1307  
        if(second>50)                      //      50 :
         {
         rtc_get_date(&date,&month,&year); //   ds1307  
         hor=date;min=month;sec=year;      //    
         }
         else
         {
         hor=hour;min=minuti;sec=second;    //    
         }
         if(tabkod[11]==hour & tabkod[10]==minuti & second==0){Play=1;}//    .    .  
         if(minuti>tabkod[10]+5){Play=0;} //  5 .  .
         
         
         break;
       } 
       
       while(regim==1)  //    
       { 
          switch(regimA)
          {
          case 0:min=tabkod[11];sec=tabkod[10];mig=1;break;//    
          case 1:sec=minuti=bufer;mig=1;mig1=0;mig2=!mig2;break;//     
          case 2:min=hour=bufer;mig=1;mig1=!mig1;mig2=0;break;//    
          case 3:tabkod[11]=hour;tabkod[10]=minuti;mig1=0;mig2=0;break;//            
          }
         break;
       }
        
       while(regim==2)  //    
       { 
          switch(regimA)
          {
          case 0:rtc_get_time(&hour,&minuti,&second);hor=hour;min=minuti;mig=0;mig1=0;mig2=1;break;//    
          case 1:min=minuti=bufer;mig=0;mig1=!mig1;mig2=1;break;//     
          case 2:hor=hour=bufer;mig=!mig;mig1=0;mig2=1;break;//    
          case 3:rtc_set_time(hour,minuti,0);mig=0;mig1=0;mig2=1;break;//    1307        
          }
         break;
       }
       
       while(regim==3)  //    
        { 
         
          switch(regimA)
          {
          case 0:hor=date;min=month;sec=year;mig=0;mig1=0;mig2=0;break;//    
          case 1:sec=year=bufer;mig=0;mig1=0;mig2=!mig2;break;//     
          case 2:min=month=bufer;mig=0;mig1=!mig1;mig2=0;break;//    
          case 3:hor=date=bufer;rtc_set_date(date,month,year);mig=!mig;mig1=0;mig2=0;break;//    1307        
          }
         break;
        }
        count=0;
        break;
       }
        
      }
     
        
}


